import 'package:resource_result/resource_result.dart';

main() {
  final Resource<int> result = parseInt("13");
  if (result.hasData) {
    Text("Parsed int successfully: ${result.data}");
  } else {
    Text("Failed to parse int: ${result.error?.message}");
  }
  //or
  convert(someStream).listen((resource) {
    resource.resolve(
        onSuccess: (someClassData) => Text(
            "Converted someClass to otherClass instance successfully: $someClassData"),
        onLoading: (_) => Text("Loading..."),
        onFailure: (error) => Text("Failed to convert: $error"));
  });
}

void Text(String text) {}

Resource<int> parseInt(String value) {
  try {
    return Success(int.parse(value));
  } catch (e) {
    return Failure.fromMessage("Failed to parse value '$value'");
  }
}

const Stream<SomeClass> someStream = Stream.empty();

class SomeClass {}

class OtherClass {}

class EmptyOtherClass implements OtherClass {}

OtherClass convertToSomeObject(SomeClass someClass) {
  return OtherClass();
}

Stream<Resource<OtherClass>> convert(Stream<SomeClass> toConvert) async* {
  yield Loading(EmptyOtherClass());
  await for (final someObject in toConvert) {
    try {
      final OtherClass converted = convertToSomeObject(someObject);
      yield Success(converted);
    } catch (e) {
      yield Failure.fromMessage("Failed convert '$someObject'");
    }
  }
}

class MyAppError extends Error{
  MyAppError(String? message) : super(message);
}

Failure failureWithMyAppError = Failure(MyAppError("My message"));
